module Oxen
  class Account
    include Mongoid::Document
    include Mongoid::Timestamps
    include ::Plug::Mixin
    array_attr :tags
    attr_accessor :password
    field :login, type: String
    field :tags, type: Array
    field :hashed_password, type: String
    field :avatar, type: Hash
    field :settings, type: Hash

    default_scope -> {where(:login.ne => "root")}

    attr_readonly :login

    validates :login, :password, presence: true
    validates :login, uniqueness: true
    validates :password, confirmation: true
    validates :password, length: { minimum: 6 , message: "密码太短"}
    before_save :hashit

    after_destroy :remove_avatar

    private

    def hashit
      self.hashed_password = Digest::SHA2.hexdigest(self.password)
    end

  end
end
